--
-- TAF 657
--
--
-- Script Specializat Pentru  TAF 657
--
-- @Autor: Mihai94
-- @Data: 08/09/2015
-- Versiunea: 1.0
--
--
-- A Nu Se Modifica Fara Permisiunea Mea...
--

TAF657= {};

function TAF657.prerequisitesPresent(specializations)
     print("......INCARCA SCRIPTUL PENTRU TAF 657 BY MIHAI94......");
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function TAF657:load(savegame)
     
    self.isSelectabil = true
    self.objectInRange = TAF657.objectInRange;
    self.CameraSpate = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.CameraSpate#index"));
    self.MPArm = SpecializationUtil.callSpecializationsFunction("MPArm");
    self.leftArm = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.characterNode1#leftArm"));
    self.rightArm = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.characterNode1#rightArm"));
    self.body = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.characterNode1#body"));
    self.index = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.characterNode1#index"));
    
    setVisibility(self.leftArm, false);
    setVisibility(self.rightArm, false);
    setVisibility(self.body, false);
    setVisibility(self.index, false);
    
    local UsaStanga = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.UsaStanga#index"));
    if UsaStanga ~= nil then
        self.UsaStanga = UsaStanga;
    end;
    
    local UsaDreapta = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.UsaDreapta#index"));
    if UsaDreapta ~= nil then
        self.UsaDreapta = UsaDreapta;
    end;
    
    local Capota = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.Capota#index"));
    if Capota ~= nil then
        self.Capota = Capota;
    end;
    
    local GrilaRadiator = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.GrilaRadiator#index"));
    if GrilaRadiator ~= nil then
        self.GrilaRadiator = GrilaRadiator;
    end;
    
    self.CureaMotor = {};
    
    local i = 0;
    
    while true do
        local key = string.format("vehicle.CureaMotor(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local node2 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#index"));
        if node2 ~= nil then
            table.insert(self.CureaMotor, {node2=node2});
        end;
        i = i +1;
    end;
    
    self.CureaCompresor = {};
    
    local i = 0;
    
    while true do
        local key = string.format("vehicle.CureaCompresor(%d)", i);
        if not hasXMLProperty(self.xmlFile, key) then
            break;
        end;
        local node2 = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#index"));
        if node2 ~= nil then
            table.insert(self.CureaCompresor, {node2=node2});
        end;
        i = i +1;
    end;
    
    self.cylinders = {};
    local i = 0;
    while true do
        local nameStr = string.format("vehicle.CilindriHidraulici(%d)", i);
        local cylinder = {};
        local cylinderStr = getXMLString(self.xmlFile, nameStr .. "#cylinder");
        if cylinderStr == nil then
            break;
        end;
        cylinder.index = Utils.indexToObject(self.components, cylinderStr);
        cylinder.directionFix = Utils.indexToObject(self.components, getXMLString(self.xmlFile, nameStr .. "#cylinderFix"));
        cylinder.punch = Utils.indexToObject(self.components, getXMLString(self.xmlFile, nameStr .. "#punch"));
        if cylinder.punch ~= nil then
            cylinder.translationFix = Utils.indexToObject(self.components, getXMLString(self.xmlFile, nameStr .. "#punchFix"));
            local ax, ay, az = getWorldTranslation(cylinder.punch);
            local bx, by, bz = getWorldTranslation(cylinder.translationFix);        
            cylinder.punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
        end;
        cylinder.scalePunch = Utils.getNoNil(getXMLBool(self.xmlFile, nameStr .. "#scale"), false);
        table.insert(self.cylinders, cylinder);
        i = i + 1;
    end;
    
    openSoundFile = Utils.getFilename("Sunete/InchideUsaStanga.wav", self.baseDirectory);
    self.openSoundId = createSample("LizardHor12nSound");
    loadSample(self.openSoundId, openSoundFile, false);
    self.openPlaying = false; 
    
    clouseSoundFile = Utils.getFilename("Sunete/DeschideUsaStanga.wav", self.baseDirectory);
    self.clouseSoundId = createSample("LizardHor12nSound");
    loadSample(self.clouseSoundId, clouseSoundFile, false);
    self.clousePlaying = false;
    
    openSoundFile = Utils.getFilename("Sunete/InchideUsaDreapta.wav", self.baseDirectory);
    self.openSoundId1 = createSample("LizardHor12nSound");
    loadSample(self.openSoundId1, openSoundFile, false);
    self.openPlaying1 = false;
    
    clouseSoundFile = Utils.getFilename("Sunete/DeschideUsaDreapta.wav", self.baseDirectory);
    self.clouseSoundId1 = createSample("LizardHor12nSound");
    loadSample(self.clouseSoundId1, clouseSoundFile, false);
    self.clousePlaying1 = false;
    
    openSoundFile = Utils.getFilename("Sunete/InchideCapota.wav", self.baseDirectory);
    self.openSoundId2 = createSample("LizardHor12nSound");
    loadSample(self.openSoundId2, openSoundFile, false);
    self.openPlaying1 = false;
    
    clouseSoundFile = Utils.getFilename("Sunete/DeschideCapota.wav", self.baseDirectory);
    self.clouseSoundId2 = createSample("LizardHor12nSound");
    loadSample(self.clouseSoundId2, clouseSoundFile, false);
    self.clousePlaying1 = false;
    
    hydraulicSoundFile = Utils.getFilename("Sunete/Hidraulica.wav", self.baseDirectory);
    self.hydraulicSoundId = createSample("hydraulicSound");
    loadSample(self.hydraulicSoundId, hydraulicSoundFile, false);
    self.hydraulicPlaying = false;
    self.hydraulicSoundAllow = false;
    
    -- Fum
    self.EF = {}
    self.EF.emittTime = 0
    
    self.EF.particleSystem = {}
    Utils.loadParticleSystem(self.xmlFile, self.EF.particleSystem, "vehicle.echaustParticleSystem", self.components, false, nil, self.baseDirectory)
    self.EF.psEmittTime = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.echaustParticleSystem#emittTime"), 1.0) * 1000
    self.EF.psEmittTime1 = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.echaustParticleSystem#emittTime1"), 1.0) * 1000
    self.EF.psEmittTime2 = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.echaustParticleSystem#emittTime2"), 1.0) * 1000
    self.EF.motorStartOffset = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.echaustParticleSystem#motorStartOffset"), 0.0) * 1000
    self.EF.startOffset1 = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.echaustParticleSystem#threshingStartOffset1"), 0.0) * 1000
    self.EF.startOffset2 = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.echaustParticleSystem#threshingStartOffset2"), 2.0) * 1000
    --------------------------------------------------------------------------------------------------------------------------------------
    self.nrep = {}; -- all variables will be stored in this table to prevent interference with other scripts 
    self.nrep.maxMotorLoad = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.newExhaustEffects#maxMotorLoad"), 20);
    self.nrep.psThreshold = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.newExhaustEffects#psThreshold"), 0.85);
    
    self.nrep.ps = {};
    Utils.loadParticleSystem(self.xmlFile, self.nrep.ps, "vehicle.newExhaustEffects.particle", self.components, false, nil, self.baseDirectory)
    --------------------------------------------------------------------------------------------------------------------------------------------------------
    self.engineUnderLoadEvent = SpecializationUtil.callSpecializationsFunction("engineUnderLoadEvent");
    self.setEngineLoadState = SpecializationUtil.callSpecializationsFunction("setEngineLoadState");
    self.engineUnderLoadEffect = {};
    self.engineUnderLoadEffect.engineIsUnderLoad = false;
    self.engineUnderLoadEffect.motorSoundPitchOffsetNormal = self.motorSoundPitchOffset;
    self.engineUnderLoadEffect.exhaustParticleSystems = {};
    local underLoadExhaustParticleSystemCount = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.underLoadExhaustParticleSystems#count"), 0);
    for i=1, underLoadExhaustParticleSystemCount do
        local namei = string.format("vehicle.underLoadExhaustParticleSystems.exhaustParticleSystem%d", i);
        Utils.loadParticleSystem(self.xmlFile, self.engineUnderLoadEffect.exhaustParticleSystems, namei, self.components, false, nil, self.baseDirectory)
    end;
    Utils.setEmittingState(self.engineUnderLoadEffect.exhaustParticleSystems, false);
    self.engineUnderLoadEffect.enabled = getXMLBool(self.xmlFile, "vehicle.engineUnderLoadEffect#enabled");
    self.engineUnderLoadEffect.enabledFLBoomKey = getXMLBool(self.xmlFile, "vehicle.engineUnderLoadEffect#FLBoomKey");
    self.engineUnderLoadEffect.enabledFLBoomMouse = getXMLBool(self.xmlFile, "vehicle.engineUnderLoadEffect#FLBoomMouse");
    self.engineUnderLoadEffect.enabledFLToolKey = getXMLBool(self.xmlFile, "vehicle.engineUnderLoadEffect#FLToolKey");
    self.engineUnderLoadEffect.enabledFLToolMouse = getXMLBool(self.xmlFile, "vehicle.engineUnderLoadEffect#FLToolMouse");
    self.engineUnderLoadEffect.enabledBABoom = getXMLBool(self.xmlFile, "vehicle.engineUnderLoadEffect#BABoom");
    self.engineUnderLoadEffect.enabledBATool = getXMLBool(self.xmlFile, "vehicle.engineUnderLoadEffect#BATool");
    self.engineUnderLoadEffect.enabledJacks = getXMLBool(self.xmlFile, "vehicle.engineUnderLoadEffect#Jacks");
    self.engineUnderLoadEffect.pitchOffset = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.engineUnderLoadEffect#pitchOffset"), 0.1);
    
    --Animatii Lama-Sapa
    local LamaFataNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.LamaFata#index"));
    if LamaFataNode ~= nil then
        self.LamaFata = {};
        self.LamaFata.node = LamaFataNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.LamaFata#minRot"));
        self.LamaFata.minRot = {};
        self.LamaFata.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.LamaFata.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.LamaFata.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.LamaFata#maxRot"));
        self.LamaFata.maxRot = {};
        self.LamaFata.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.LamaFata.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.LamaFata.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.LamaFata.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.LamaFata#rotTime"), 2)*1000;
        self.LamaFata.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.LamaFata#touchRotLimit"), 10));
    end;
    
    local SapaSpateNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.SapaSpate#index"));
    if SapaSpateNode ~= nil then
        self.SapaSpate = {};
        self.SapaSpate.node = SapaSpateNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.SapaSpate#minRot"));
        self.SapaSpate.minRot = {};
        self.SapaSpate.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.SapaSpate.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.SapaSpate.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(self.xmlFile, "vehicle.SapaSpate#maxRot"));
        self.SapaSpate.maxRot = {};
        self.SapaSpate.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.SapaSpate.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.SapaSpate.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.SapaSpate.rotTime = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.SapaSpate#rotTime"), 2)*1000;
        self.SapaSpate.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.SapaSpate#touchRotLimit"), 10));
    end;
    
end;

function TAF657:delete()
Utils.deleteParticleSystem(self.EF.particleSystem)
Utils.deleteParticleSystem(self.engineUnderLoadEffect.exhaustParticleSystems);
if self.nrep.ps ~= nil then
        Utils.deleteParticleSystem(self.nrep.ps);
    end;
end;

function TAF657:readStream(streamId, connection)
end;

function TAF657:writeStream(streamId, connection)
end;

function TAF657:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
end;

function TAF657:getSaveAttributesAndNodes(nodeIdent)
end;

function TAF657:mouseEvent(posX, posY, isDown, isUp, button)
end;

function TAF657:keyEvent(unicode, sym, modifier, isDown)

-- Animatii Lama-Sapa
if sym == Input.KEY_n then
        self.LamaFataMin= isDown;
end;
if sym == Input.KEY_j then
        self.LamaFataMax= isDown;
end;

if sym == Input.KEY_m then
        self.SapaSpateMin= isDown;
end;
if sym == Input.KEY_k then
        self.SapaSpateMax= isDown;
end;

-- activare comenzi
if isDown then
        if sym == Input.KEY_j or sym == Input.KEY_n or sym == Input.KEY_k or sym == Input.KEY_m then
            self.hydraulicSoundAllow = true;
        end;
    else
        self.hydraulicSoundAllow = false;
    end;
end;

function TAF657:update(dt)

-- Fum
if self:getIsActive() and self.isMotorStarted then        
        local mLoad =  self.motor.motorLoad / self.nrep.maxMotorLoad; -- converting the individual motor load to 0-1 range value     
        if mLoad > self.nrep.psThreshold then
            Utils.setEmittingState(self.nrep.ps, true);
        else
            Utils.setEmittingState(self.nrep.ps, false)
        end;
    end;
    self.engineUnderLoadEffect.engineIsUnderLoad = false;

-- Animatii Mobile

if self.isEntered then
        if Input.isKeyPressed(Input.KEY_lshift) then
                setCamera(self.CameraSpate);
           end;
     end;  

if self.isEntered then
        if self.camIndex==2 then
            self:MPArm(2);
        else
            self:MPArm(1);
        end;
    end;     
    
    if self.isClient and not self:getIsActiveForInput(false) then
        if self:objectInRange(self.UsaStanga) then

            if InputBinding.hasEvent(InputBinding.DeschideUsaStanga) then
                if self.animationParts[1].clipEndTime then
                    self:setAnimationTime(1, self.animationParts[1].startPosition);
                    self.sound1 = true;
                    self.sound2 = false;
                else
                    self:setAnimationTime(1, self.animationParts[1].animDuration);
                    self.sound1 = false;
                    self.sound2 = true; 
                end;
            end;
            if self.animationParts[1].clipEndTime then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Deschide_Usa_Stanga"), self.typeDesc), InputBinding.DeschideUsaStanga);            
            else
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Inchide_Usa_Stanga"), self.typeDesc), InputBinding.DeschideUsaStanga);
            end;
        end;
    end;

    if self.isClient and not self:getIsActiveForInput(false) then
        if self:objectInRange(self.UsaDreapta) then
            if InputBinding.hasEvent(InputBinding.DeschideUsaDreapta) then
                if self.animationParts[2].clipEndTime then
                    self:setAnimationTime(2, self.animationParts[2].startPosition);
                    self.sound3 = true;
                    self.sound4 = false;
                else
                    self:setAnimationTime(2, self.animationParts[2].animDuration);
                    self.sound3 = false;
                    self.sound4 = true; 
                end;
            end;
            if self.animationParts[2].clipEndTime then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Deschide_Usa_Dreapta"), self.typeDesc), InputBinding.DeschideUsaDreapta);            
            else
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Inchide_Usa_Dreapta"), self.typeDesc), InputBinding.DeschideUsaDreapta);
            end;
        end;
    end;
    
    if self.isClient and not self:getIsActiveForInput(false) then
        if self:objectInRange(self.Capota) then
            if InputBinding.hasEvent(InputBinding.DemonteazaCapota) then
                if self.animationParts[3].clipEndTime then
                    self:setAnimationTime(3, self.animationParts[3].startPosition);
                    self.sound5 = true;
                    self.sound6 = false;
                else
                    self:setAnimationTime(3, self.animationParts[3].animDuration);
                    self.sound5 = false;
                    self.sound6 = true; 
                end;
            end;
            if self.animationParts[3].clipEndTime then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Monteaza_Capota"), self.typeDesc), InputBinding.DemonteazaCapota);            
            else
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Demonteaza_Capota"), self.typeDesc), InputBinding.DemonteazaCapota);
            end;
        end;
    end;
    
    if self.isClient and not self:getIsActiveForInput(false) then
        if self:objectInRange(self.GrilaRadiator) then
            if InputBinding.hasEvent(InputBinding.DeschideGrila) then
                if self.animationParts[30].clipEndTime then
                    self:setAnimationTime(30, self.animationParts[30].startPosition);
                    self.sound5 = true;
                    self.sound6 = false;
                else
                    self:setAnimationTime(30, self.animationParts[30].animDuration);
                    self.sound5 = false;
                    self.sound6 = true; 
                end;
            end;
            if self.animationParts[30].clipEndTime then
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Deschide_Grila"), self.typeDesc), InputBinding.DeschideGrila);            
            else
                g_currentMission:addHelpButtonText(string.format(g_i18n:getText("Inchide_Grila"), self.typeDesc), InputBinding.DeschideGrila);
            end;
        end;
    end;
    
    if self.isMotorStarted then
        for _, part in pairs(self.CureaMotor) do
            setShaderParameter(part.node2, "uvScrollSpeed", 0, 2, 0, 0, false);
        end;
        for _, part in pairs(self.CureaCompresor) do
            setShaderParameter(part.node2, "uvScrollSpeed", 0, 2, 0, 0, false);
        end;
        self:setAnimationTime(4, 1);
    else
        for _, part in pairs(self.CureaMotor) do
            setShaderParameter(part.node2, "uvScrollSpeed", 0, 0, 0, 0, false);
        end;
        for _, part in pairs(self.CureaCompresor) do
            setShaderParameter(part.node2, "uvScrollSpeed", 0, 0, 0, 0, false);
        end;
        self:setAnimationTime(4, 0);
    end;
    
-- Sunete Animatii
    if self.sound1 then
       if not self.openPlaying then
            playSample(self.openSoundId, 1, 3, 3);
            self.openPlaying = true;
        end;    
    else
        if self.openPlaying then
            stopSample(self.openSoundId);
            self.openPlaying = false;
        end;      
    end;    
        if self.sound2 then
       if not self.clousePlaying then
            playSample(self.clouseSoundId, 1, 3, 3);
            self.clousePlaying = true;
        end;  
    else
        if self.clousePlaying then
           stopSample(self.clouseSoundId);
           self.clousePlaying = false;
        end;     
   end;
   
   if self.sound3 then
       if not self.openPlaying1 then
            playSample(self.openSoundId1, 1, 3, 3);
            self.openPlaying1 = true;
        end;    
    else
        if self.openPlaying1 then
            stopSample(self.openSoundId1);
            self.openPlaying1 = false;
        end;      
    end;    
        if self.sound4 then
       if not self.clousePlaying1 then
            playSample(self.clouseSoundId1, 1, 3, 3);
            self.clousePlaying1 = true;
        end;  
    else
        if self.clousePlaying1 then
           stopSample(self.clouseSoundId1);
           self.clousePlaying1 = false;
        end;     
   end;
   
   if self.sound5 then
       if not self.openPlaying2 then
            playSample(self.openSoundId2, 1, 3, 3);
            self.openPlaying2 = true;
        end;    
    else
        if self.openPlaying2 then
            stopSample(self.openSoundId2);
            self.openPlaying2 = false;
        end;      
    end;    
        if self.sound6 then
       if not self.clousePlaying2 then
            playSample(self.clouseSoundId2, 1, 3, 3);
            self.clousePlaying2 = true;
        end;  
    else
        if self.clousePlaying2 then
           stopSample(self.clouseSoundId2);
           self.clousePlaying2 = false;
        end;     
   end;
   
   -- Turometru
   if self.isMotorStarted then
            self:setAnimationTime(5,self.animationParts[5].animDuration);
        else
            self:setAnimationTime(5,self.animationParts[5].offSet);
        end;
         if self.lastSpeed*3600 > 3 then
            self:setAnimationTime(6,self.animationParts[6].animDuration);
        else
            self:setAnimationTime(6,self.animationParts[6].offSet);
        end;
         if self.lastSpeed*3600 > 6 then
            self:setAnimationTime(7,self.animationParts[7].animDuration);
        else
            self:setAnimationTime(7,self.animationParts[7].offSet);
        end;
         if self.lastSpeed*3600 > 9 then
            self:setAnimationTime(8,self.animationParts[8].animDuration);
        else
            self:setAnimationTime(8,self.animationParts[8].offSet);
        end;
         if self.lastSpeed*3600 > 12 then
            self:setAnimationTime(9,self.animationParts[9].animDuration);
        else
            self:setAnimationTime(9,self.animationParts[9].offSet);
        end;
        if self.lastSpeed*3600 > 15 then
            self:setAnimationTime(10,self.animationParts[10].animDuration);
        else
            self:setAnimationTime(10,self.animationParts[10].offSet);
        end;
         if self.lastSpeed*3600 > 18 then
            self:setAnimationTime(11,self.animationParts[11].animDuration);
        else
            self:setAnimationTime(11,self.animationParts[11].offSet);
        end;
        if self.lastSpeed*3600 > 21 then
            self:setAnimationTime(12,self.animationParts[12].animDuration);
        else
            self:setAnimationTime(12,self.animationParts[12].offSet);
        end;
         if self.lastSpeed*3600 > 24 then
            self:setAnimationTime(13,self.animationParts[13].animDuration);
        else
            self:setAnimationTime(13,self.animationParts[13].offSet);
        end;
        if self.lastSpeed*3600 > 27 then
            self:setAnimationTime(14,self.animationParts[14].animDuration);
        else
            self:setAnimationTime(14,self.animationParts[14].offSet);
        end;
         if self.lastSpeed*3600 > 30 then
            self:setAnimationTime(15,self.animationParts[15].animDuration);
        else
            self:setAnimationTime(15,self.animationParts[15].offSet);
        end;    
        if self.lastSpeed*3600 > 4 then
            self:setAnimationTime(16,self.animationParts[16].animDuration);
        else
            self:setAnimationTime(16,self.animationParts[16].offSet);
        end;
        if self.lastSpeed*3600 > 33 then
            self:setAnimationTime(17,self.animationParts[17].animDuration);
        else
            self:setAnimationTime(17,self.animationParts[17].offSet);
        end;
         if self.lastSpeed*3600 > 36 then
            self:setAnimationTime(18,self.animationParts[18].animDuration);
        else
            self:setAnimationTime(18,self.animationParts[18].offSet);
        end;
         if self.lastSpeed*3600 > 39 then
            self:setAnimationTime(19,self.animationParts[19].animDuration);
        else
            self:setAnimationTime(19,self.animationParts[19].offSet);
        end;
         if self.lastSpeed*3600 > 42 then
            self:setAnimationTime(20,self.animationParts[20].animDuration);
        else
            self:setAnimationTime(20,self.animationParts[20].offSet);
        end;
        if self.lastSpeed*3600 > 45 then
            self:setAnimationTime(21,self.animationParts[21].animDuration);
        else
            self:setAnimationTime(21,self.animationParts[21].offSet);
        end;
         if self.lastSpeed*3600 > 48 then
            self:setAnimationTime(22,self.animationParts[22].animDuration);
        else
            self:setAnimationTime(22,self.animationParts[22].offSet);
        end;
        if self.lastSpeed*3600 > 51 then
            self:setAnimationTime(23,self.animationParts[23].animDuration);
        else
            self:setAnimationTime(23,self.animationParts[23].offSet);
        end;
         if self.lastSpeed*3600 > 54 then
            self:setAnimationTime(24,self.animationParts[24].animDuration);
        else
            self:setAnimationTime(24,self.animationParts[24].offSet);
        end;
        if self.lastSpeed*3600 > 57 then
            self:setAnimationTime(25,self.animationParts[25].animDuration);
        else
            self:setAnimationTime(25,self.animationParts[25].offSet);
        end;
         if self.lastSpeed*3600 > 60 then
            self:setAnimationTime(26,self.animationParts[26].animDuration);
        else
            self:setAnimationTime(26,self.animationParts[26].offSet);
        end;
        
        --temperaturi presiune
        if self.isMotorStarted then
            self:setAnimationTime(27,self.animationParts[27].animDuration);
        else
            self:setAnimationTime(27,self.animationParts[27].offSet);
        end;
        if self.isMotorStarted then
            self:setAnimationTime(28,self.animationParts[28].animDuration);
        else
            self:setAnimationTime(28,self.animationParts[28].offSet);
        end;
        if self.isMotorStarted then
            self:setAnimationTime(29,self.animationParts[29].animDuration);
        else
            self:setAnimationTime(29,self.animationParts[29].offSet);
        end;
        
        -- Indicator motorina
        if self.isMotorStarted and self.fuelFillLevel > 4 then
        self:setAnimationTime(31,self.animationParts[31].animDuration);
        else
            self:setAnimationTime(31,self.animationParts[31].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 8 then
        self:setAnimationTime(32,self.animationParts[32].animDuration);
        else
            self:setAnimationTime(32,self.animationParts[32].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 12 then
        self:setAnimationTime(33,self.animationParts[33].animDuration);
        else
            self:setAnimationTime(33,self.animationParts[33].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 16 then
        self:setAnimationTime(34,self.animationParts[34].animDuration);
        else
            self:setAnimationTime(34,self.animationParts[34].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 20 then
        self:setAnimationTime(35,self.animationParts[35].animDuration);
        else
            self:setAnimationTime(35,self.animationParts[35].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 24 then
        self:setAnimationTime(36,self.animationParts[36].animDuration);
        else
            self:setAnimationTime(36,self.animationParts[36].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 28 then
        self:setAnimationTime(37,self.animationParts[37].animDuration);
        else
            self:setAnimationTime(37,self.animationParts[37].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 32 then
        self:setAnimationTime(38,self.animationParts[38].animDuration);
        else
            self:setAnimationTime(38,self.animationParts[38].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 36 then
        self:setAnimationTime(39,self.animationParts[39].animDuration);
        else
            self:setAnimationTime(39,self.animationParts[39].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 40 then
        self:setAnimationTime(40,self.animationParts[40].animDuration);
        else
            self:setAnimationTime(40,self.animationParts[40].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 44 then
        self:setAnimationTime(41,self.animationParts[41].animDuration);
        else
            self:setAnimationTime(41,self.animationParts[41].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 48 then
        self:setAnimationTime(42,self.animationParts[42].animDuration);
        else
            self:setAnimationTime(42,self.animationParts[42].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 52 then
        self:setAnimationTime(43,self.animationParts[43].animDuration);
        else
            self:setAnimationTime(43,self.animationParts[43].offSet);
        end;
        if self.isMotorStarted and self.fuelFillLevel > 56 then
        self:setAnimationTime(44,self.animationParts[44].animDuration);
        else
            self:setAnimationTime(44,self.animationParts[44].offSet);
        end;
        
    -- Animatii Lama-Sapa
        if self.isMotorStarted then
    local doRotate = self.LamaFataMin or self.LamaFataMax
    if self.LamaFata ~= nil and doRotate then
            local x, y, z = getRotation(self.LamaFata.node);        
            local rot = {x,y,z};
            local newRot = Utils.getMovedLimitedValues(rot, self.LamaFata.maxRot, self.LamaFata.minRot, 3, self.LamaFata.rotTime, dt, not self.LamaFataMin);
            setRotation(self.LamaFata.node, unpack(newRot));
        self:engineUnderLoadEvent(self.engineUnderLoadEffect.enabledBABoom);
       if self.hydraulicSoundAllow and not self.hydraulicPlaying then
            playSample(self.hydraulicSoundId,0,0.5,0);
            self.hydraulicPlaying = true;
    end;
    elseif not self.hydraulicSoundAllow and self.hydraulicPlaying then
        stopSample(self.hydraulicSoundId);
        self.hydraulicPlaying = false;
    end;
end;

    if self.isMotorStarted then
    local doRotate = self.SapaSpateMin or self.SapaSpateMax
    if self.SapaSpate ~= nil and doRotate then
            local x, y, z = getRotation(self.SapaSpate.node);        
            local rot = {x,y,z};
            local newRot = Utils.getMovedLimitedValues(rot, self.SapaSpate.maxRot, self.SapaSpate.minRot, 3, self.SapaSpate.rotTime, dt, not self.SapaSpateMin);
            setRotation(self.SapaSpate.node, unpack(newRot));
        self:engineUnderLoadEvent(self.engineUnderLoadEffect.enabledBABoom);
       if self.hydraulicSoundAllow and not self.hydraulicPlaying then
            playSample(self.hydraulicSoundId,0,0.5,0);
            self.hydraulicPlaying = true;
    end;
    elseif not self.hydraulicSoundAllow and self.hydraulicPlaying then
        stopSample(self.hydraulicSoundId);
        self.hydraulicPlaying = false;
    end;
end;
    
end;

function TAF657:updateTick(dt)    
-- Fum
if self:getIsActive() then
        if self.EF.threshingEmitting then
            self.EF.emittTime = self.EF.emittTime + dt
            if self.EF.emittTime > self.EF.startOffset2 + self.EF.psEmittTime2 then
                self.EF.threshingEmitting = false
            end

            local shouldEmitt1 = self.EF.emittTime > self.EF.startOffset1 and self.EF.emittTime < self.EF.startOffset1 + self.EF.psEmittTime1
            local shouldEmitt2 = self.EF.emittTime > self.EF.startOffset2 and self.EF.emittTime < self.EF.startOffset2 + self.EF.psEmittTime2
            Utils.setEmittingState(self.EF.particleSystem, shouldEmitt1 or shouldEmitt2)
        end
    end
    if self.isMotorStarted then
        if not self.EF.motorStartPlayed then
            self.EF.motorStartPlayed = true
            self.EF.motorEmitting = true
        end

        if self.EF.motorEmitting then
            self.EF.emittTime = self.EF.emittTime + dt
            if self.EF.emittTime > self.EF.motorStartOffset + self.EF.psEmittTime then
                self.EF.motorEmitting = false
            end

            local shouldEmitt = self.EF.emittTime > self.EF.motorStartOffset and self.EF.emittTime < self.EF.motorStartOffset + self.EF.psEmittTime
            Utils.setEmittingState(self.EF.particleSystem, shouldEmitt)
        end
    else
        self.EF.emittTime = 0
        self.EF.motorEmitting = false
        self.EF.motorStartPlayed = false
    end

for _, cylinder in pairs(self.cylinders) do
        local ax, ay, az = getWorldTranslation(cylinder.index);
        local bx, by, bz = getWorldTranslation(cylinder.directionFix);
        local x, y, z = worldDirectionToLocal(getParent(cylinder.index), bx-ax, by-ay, bz-az);
        local xU, yU, zU = 0, 1, 0;
        if math.abs(y) > 0.99 * Utils.vector3Length(x, y, z) then
            yU = 0;
            if y > 0 then
                zU = 1;
            else
                zU = -1;
            end;
        end;
        setDirection(cylinder.index, x, y, z, xU, yU, zU);
        if cylinder.punchDistance ~= nil then
            local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
            if cylinder.scalePunch then
                local xS, yS, zS = getScale(cylinder.punch);
                local newS = xS * (distance / cylinder.punchDistance);
                setScale(cylinder.punch, xS, yS, newS);
            else
                setTranslation(cylinder.punch, 0, 0, distance-cylinder.punchDistance);
            end;
        end;
    end;    
end;

function TAF657:objectInRange(object)
    if g_currentMission.player ~= nil and object ~= nil then
        local nearestDistance = 2;
        local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
        local px, py, pz = getWorldTranslation(object); 
        local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);    
        if distance < nearestDistance then
            return true;
        else
            return false;
        end;
    else
        return false;
    end;
end;

function TAF657:draw()    
end;

function TAF657:onTurnedOn()
    if self:getIsActive() then
        self.EF.emittTime = 0
        self.EF.threshingEmitting = true
        self.EF.motorEmitting = false
    end
end

function TAF657:onTurnedOff()
    if self:getIsActive() then
        self.EF.threshingEmitting = false
    end
end
function TAF657:onEnter()
end;

function TAF657:onLeave()
setVisibility(self.leftArm, false);
    setVisibility(self.rightArm, false);
    setVisibility(self.body, false);
    setVisibility(self.index, false);
-- Fum    
    if self.nrep.ps then
        Utils.setEmittingState(self.nrep.ps, false);
    end;
end;

function TAF657:engineUnderLoadEvent(componentEnabledStatus)
    if self.engineUnderLoadEffect.enabled and componentEnabledStatus and self.isMotorStarted then
       self.engineUnderLoadEffect.engineIsUnderLoad = true;
    end;
end;

function TAF657:setEngineLoadState()
         if self.engineUnderLoadEffect.engineIsUnderLoad then
        if self.motorSoundPitchOffset == self.engineUnderLoadEffect.motorSoundPitchOffsetNormal then
            self.motorSoundPitchOffset = self.engineUnderLoadEffect.motorSoundPitchOffsetNormal - math.abs(self.engineUnderLoadEffect.pitchOffset);
            Utils.setEmittingState(self.engineUnderLoadEffect.exhaustParticleSystems, true);
        end;
    else
        if self.motorSoundPitchOffset ~= self.engineUnderLoadEffect.motorSoundPitchOffsetNormal then
            self.motorSoundPitchOffset = self.engineUnderLoadEffect.motorSoundPitchOffsetNormal;
            Utils.setEmittingState(self.engineUnderLoadEffect.exhaustParticleSystems, false);
        end;
    end;
end;

function TAF657:validateAttacherJoint(implement, jointDesc, dt)
end;

function TAF657:attachImplement(implement)
end;

function TAF657:detachImplement(implementIndex)
end;

function TAF657:MPArm(mode, noEventSend)
    ArmEvent.sendEvent(self, mode, noEventSend);
    if mode == 2 then
        setVisibility(self.leftArm, true);
        setVisibility(self.rightArm, true);
        setVisibility(self.body, true);
        setVisibility(self.index, false);
    elseif mode == 1 then
        setVisibility(self.leftArm, true);
        setVisibility(self.rightArm, true);
        setVisibility(self.body, true);
        setVisibility(self.index, true);
    end;
end;

--Event Character Node**********************************************************************************************************************************************************************************
ArmEvent = {};
ArmEvent_mt = Class(ArmEvent, Event);

InitEventClass(ArmEvent, "ArmEvent");

function ArmEvent:emptyNew()
    local self = Event:new(ArmEvent_mt);
    self.className="ArmEvent";
    return self;
end;

function ArmEvent:new(vehicle, mode)
    local self = ArmEvent:emptyNew()
    self.vehicle = vehicle;
    self.mode = mode;
    return self;
end;

function ArmEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.mode = streamReadInt32(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function ArmEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
    streamWriteInt32(streamId, self.mode);
end;

function ArmEvent:run(connection)
    self.vehicle:MPArm(1, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(ArmEvent:new(self.vehicle, 1), nil, connection, self.vehicle);
    end;
end;

function ArmEvent.sendEvent(vehicle, mode, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(ArmEvent:new(vehicle, mode), nil, nil, vehicle);
        else
            g_client:getServerConnection():sendEvent(ArmEvent:new(vehicle, mode));
        end;
    end;
end;